package com.zd.common.security.utils;

import java.util.*;
import java.util.stream.Collectors;

import com.zd.common.core.constant.Constants;
import com.zd.common.core.utils.SpringUtils;
import com.zd.common.core.utils.StringUtils;
import com.zd.common.redis.service.RedisService;
import com.zd.system.api.domain.SysDictData;

/**
 * 字典工具类
 *
 * @author zd
 */
public class DictUtils {
    /**
     * 设置字典缓存
     *
     * @param key       参数键
     * @param dictDatas 字典数据列表
     */
    public static void setDictCache(String key, List<SysDictData> dictDatas) {
        SpringUtils.getBean(RedisService.class).setCacheObject(getCacheKey(key), dictDatas);
    }

    /**
     * 获取字典缓存
     *
     * @param key 参数键
     * @return dictDatas 字典数据列表
     */
    public static List<SysDictData> getDictCache(String key) {
        Object cacheObj = SpringUtils.getBean(RedisService.class).getCacheObject(getCacheKey(key));
        if (StringUtils.isNotNull(cacheObj)) {
            List<SysDictData> dictDatas = StringUtils.cast(cacheObj);
            return dictDatas;
        }
        return Collections.emptyList();
    }

    public static Map<String,String> getDictCacheMap(String key) {
        return getDictCache(key).stream().collect(Collectors.toMap(a -> a.getDictValue(), b -> b.getDictLabel()));
    }
    /**
     * 获取字典缓存
     *
     * @param key 参数键
     * @param value 字典值
     * @return dictDatas 字典数据列表
     */
    public static String getDictCacheLable(String key,String value) {
        if(value==null) return null;
        List<SysDictData> dictCache = getDictCache(key);
        return Optional.ofNullable(dictCache).orElseGet(Collections::emptyList)
                .stream()
                .filter(a -> a.getDictValue().equals(value))
                .map(a -> a.getDictLabel())
                .findFirst()
                .orElse(null);
    }


    /**
     * 删除指定字典缓存
     *
     * @param key 字典键
     */
    public static void removeDictCache(String key) {
        SpringUtils.getBean(RedisService.class).deleteObject(getCacheKey(key));
    }

    /**
     * 清空字典缓存
     */
    public static void clearDictCache() {
        Collection<String> keys = SpringUtils.getBean(RedisService.class).keys(Constants.SYS_DICT_KEY + "*");
        SpringUtils.getBean(RedisService.class).deleteObject(keys);
    }

    /**
     * 设置cache key
     *
     * @param configKey 参数键
     * @return 缓存键key
     */
    public static String getCacheKey(String configKey) {
        return Constants.SYS_DICT_KEY + configKey;
    }
}
